<?php // récupération des variables
require_once("variablepa.php");

$msg_init_connexion_frontal = "Debut de com";

//Conversion « Année/Mois/Jour Heures:Minutes:secondes » -> Date 32bits*********************
function ymdhms2date (//routine mise sous forme php
  /* output: seconds since 2000/03/01-00:00:00 */
  $year,	/* input: year since 2000 */
  $month,	/* input: month 1:jan 2:feb ... 12:dec */
  $day,	/* input: day within month, between 1 and 31 */
  $hours,	/* input: between 0 and 23 */
  $minutes,	/* input: between 0 and 59 */
  $seconds	/* input: between 0 and 59 */
) {
  if ( $month < 3 ) { $year = $year - 1;  $month = $month + 12; }

  return ((( floor(($year * 1461) / 4) + floor((($month + 1) * 153) / 5) - 123 + $day) * 24 + $hours)* 60 + $minutes) * 60 + $seconds;
}
//******************************************************************************************

//Conversion Date 32bits  -> « Année/Mois/Jour Heures:Minutes:secondes »********************
function date2ymdwhms ( //routine mise sous forme php
  $date,	/* input: of seconds since 2000/03/01-00:00:00 */
  &$year,	/* output: year since 2000 */
  &$month,	/* output: month 1:jan 2:feb ... 12:dec */
  &$day,	/* output: day within month, between 1 and 31 */
  &$weekday,	/* output: 0:mon 1:tue 2:wed 3:thu 4:fri 5:sat 6:sun */
  &$hours,	/* output: between 0 and 23 */
  &$minutes,	/* output: between 0 and 59 */
  &$seconds	/* output: between 0 and 59 */
) 
  {
  	/* modulo: x % y = x - ( ( x / y ) * y ); */
  $seconds = $date % 60; $quo = floor($date / 60);	/* quo = minutes */
  $minutes = $quo % 60;  $quo = floor($quo / 60);	    	/* quo = hours */
  $hours = $quo % 24;    $quo = floor($quo / 24);		    /* quo = days */
  $weekday = ( $quo + 2 ) % 7;
  $rem = $quo % 1461; 
  $quo = floor($quo / 1461);	/* 1461 = 365 + 365 + 365 + 366 */

  if ( $rem == 1460 ) { $year = ( 4 * $quo ) + 4;  $month = 2;  $day = 29; }

  else 
  {
    $year = ( 4 * $quo ) + floor( $rem / 365 );  $rem = $rem % 365;
    $month = floor( ( ( $rem + 31 ) * 5 ) / 153 ) + 2;
    $day = ( $rem + 123 ) - floor( ( ( $month + 1 ) * 153 ) / 5 );

    if ( $month > 12 ) 
		{ $month = $month - 12;  $year = $year + 1; }
  }
}
//******************************************************************************************

//Analyse de la chaine (int)************************************************************
function is_entier($chaine)			//Vérifie qu'une chaine est bien un entier
{
	$taille = strlen($chaine);
	for ($i = 0; $i < $taille; $i++)
	{
		if( !(ord($chaine[$i])>=48 && ord($chaine[$i])<=57) )
			return(0);
	}
	return(1);
}
//************************************************************************************

//Analyse de la chaine hexa***********************************************************
function is_hexa($chaine)			//Vérifie qu'une chaine est bien en hexadecimale
{
	$taille = strlen($chaine);
	for ($i = 0; $i < $taille; $i++)
	{
		if( !(ord($chaine[$i])>=48 && ord($chaine[$i])<=57) && !( ord($chaine[$i])>=65 && ord($chaine[$i])<=70 )  )
			return(0);	
	}
	return(1);		
}
//************************************************************************************

//Formation de la date à envoyer******************************************************
function mise_en_forme_date_envoi()
{
	$resultat = ymdhms2date(date("y"),date("n"),date("j"),date("G"),date("i"),date("s"));
	$resultat = strtoupper(dechex($resultat));
	$vide = 8-strlen($resultat);
	for ($i = 1; $i <= $vide; $i++)
	{
		$resultat="0".$resultat;
	}
	
	return($resultat);
}
//************************************************************************************

//Formation de la date reçue******************************************************
function mise_en_forme_date_recu($chaine)
{
	$chaine = hexdec($chaine);
	date2ymdwhms($chaine,$year,$month,$day,$weekday,$hours,$minutes,$seconds);
	$year = intval($year);
	$year +=2000;
	$year 		= strval($year);
	$month 		= str_pad($month,2,		"0", STR_PAD_LEFT);
	$day 		= str_pad($day,2,		"0", STR_PAD_LEFT);
	$hours 		= str_pad($hours,		"0", STR_PAD_LEFT);
	$minutes 	= str_pad($minutes,2,	"0", STR_PAD_LEFT);
	$seconds 	= str_pad($seconds,2,	"0", STR_PAD_LEFT);
	$chaine = $year.$month.$day.$hours.$minutes.$seconds;
	return($chaine);
}
//************************************************************************************

//Conversion du Format Hexadecimal en Format decimale*********************************
function chaine_dec($chaine,$taille)
{
	$chaine = hexdec($chaine);
	$chaine = str_pad($chaine,$taille,"0", STR_PAD_LEFT);
	return($chaine);
}
//************************************************************************************

//Fermeture d'une socket**************************************************************
function ferme_socket($socket)
{
	if(socket_close($socket))
	{
		if($debug==1)
		{
			echo "Erreur fermeture socket <BR>";
			echo socket_strerror(socket_last_error());
			echo "<BR>";
		}
	}
	else
	{
		if($debug==1)
			echo "Fermeture socket OK<BR>";
	}
}
//************************************************************************************

//Envoi de la réponse en http***************************************************
function envoie_trame_http($chaine,$addr_ip)
{	/*l'argument de content "10 est à mettre à "0 pour event.php*/
	echo "<META HTTP-EQUIV=\"refresh\" CONTENT=\"10; URL=http://$addr_ip/srx/transmetteur.php?envoi_frontal=$chaine\">";
			echo "reponse au transmmetteur : $chaine <BR>";
}
//************************************************************************************

//Connexion*********************************************************************
function connexion($addr_ip, $port)
{	
	$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);

	/*Premiere tentative de connexion*/	
	$essai_de_connexion = socket_connect($socket,$addr_ip, $port);
	$nb_tentative = 1;
	if($debug==1)
		echo "tentative connexion N $nb_tentative<BR>";
	/*********************************/

	/*Si la première tentative à échoué j'entre dans la boucle*******************/
	while( !$essai_de_connexion && $nb_tentative<4 )	//4 tentatives de connexion
	{ 
		echo socket_strerror(socket_last_error()); echo "<BR>";
		$essai_de_connexion = socket_connect($socket,$addr_ip, $port);
		$nb_tentative = $nb_tentative +1;
		if($debug==1)
			echo "tentative connexion N $nb_tentative<BR>";
		sleep(3);//Attend 3 secondes avant la nouvelle tentative
	}
	/****************************************************************************/

	if(!$essai_de_connexion)						//l'essai de connexion a échoué
	{
		if($debug==1)
			echo "Echec de la connexion<BR>";
		return(0);
	}
	else											//l'essai de connexion a réussi
	{
		
		return($socket);
			
		
	}
}
//******************************************************************************

//Envoi d'une trame TCP*********************************************************
function envoie_trame_socket($socket,$chaine,$label,$debug)
{
	/*Premiere tentative d'envoi*************************************************/	
	$essai_d_envoie = socket_send ($socket,$chaine,strlen($chaine), 0x1);
	$nb_tentative = 1;
	if($debug==1)
		echo "tentative envoie de trame N $nb_tentative<BR>";
	/****************************************************************************/

	/*Si la première tentative à échoué j'entre dans la boucle*******************/
	while( !$essai_d_envoie && $nb_tentative < 4)	//4 tentatives d'envoi
	{
		if($debug==1)
		{	echo socket_strerror(socket_last_error());
			echo "<BR>";
		}
		$essai_d_envoie = socket_send ($socket,$chaine,strlen($chaine), 0x1);
		$nb_tentative = $nb_tentative +1;
		if($debug==1)
			echo "tentative envoie de trame N $nb_tentative<BR>";	
		sleep(1);//Attend 1 seconde avant la nouvelle tentative
	}
	/****************************************************************************/

	if(!$essai_d_envoie)							//l'essai d'envoi a échoué
	{
		if($debug==1)
			echo "Echec de l'Envoi vers $label<BR>";
		return(0);
	}
	else											//l'essai d'envoi a réussi
	{
		if($debug==1)
			echo "Debut de l'envoie d'une trame reussi<BR>";
	
		/*Avec "recv" j'attend l'acquittement du frontal*/
		$taille = 1024;
		$essai_recv = socket_recv($socket,$buffer,$taille,0);
		if(!$essai_recv)							//recv a échoué
		{ 
			if($debug==1)
			{
				echo "Echec de la réception de OK<BR>";
				echo socket_strerror(socket_last_error());
				echo "<BR>";
			}
			return(0);
		}
		else										//recv a reussi
		{
			if($debug==1)
				echo "La page event a recue : $buffer<BR>";

			/*Test du message reçu*/
			$comparaison = strncmp($buffer,"OK",strlen("OK"));
			if($comparaison)						//message reçu non conforme
			{	
				if($debug==1)
				{
					echo "comparaison = $comparaison<BR>";
					echo "La chaine recue est incorrecte.<BR>";
				}
				return(0);
			}
			else									//message reçu conforme
			{
				if($debug==1)
					echo "La reponse est conforme<BR>";
				return $buffer;
			}
		}
	}
}
//************************************************************************************

//Récupération des champs recus*******************************************************

/*Initialisation des variables globales*/
$nbEvt = 0;		//1 : envoi au frontal en decimal, 0:envoi au frontal en hexadecimal.
$trame_trsm_conforme = 0;
$protocole_frontal_OK = 0; 
$debug=0;
/**************************************/

$IP_client = $_SERVER['REMOTE_ADDR'];
$formId = $_GET['id'];
$formTyp = $_GET['typ'];
$formEvt = $_GET['evt'];
$formTrm = $_GET['trm'];
$formTel = $_GET['tel'];

if($debug==1)
{
	echo 'les informations on bien ete recues!',"  <BR>  ";
	echo "<p> Identificateur:<input name='id'  value = \"$formId\"  type='text'> </p>";
	echo "<p> Type :<input          name='typ' value = \"$formTyp\" type='text'> </p>";
	echo "<p> Evenement :<input     name='evt' value = \"$formEvt\" type='text'> </p>";
	echo "<p> Tel :<input         name='tel' value = \"$formTel\" type='text'> </p>";
	echo "<p> Trm :<input         name='trm' value = \"$formTrm\" type='text'> </p>";
}
//************************************************************************************

//Vérification de la conformité de la trame et envoie eventuel dèune la reponse*******
if (($formId=="") || ($formTyp=="") || ($formEvt=="") || ($formTel=="") || ($formTrm=="") )
{
	if($debug==1)
	{
		echo "Erreur <BR>";
		if ($formId=="")
		{
			echo "le champ Identificateur est vide <BR> ";
			//envoie_trame_http("IDvide");
		}
		if ($formTyp=="")
		{
			echo "le champ Type est vide <BR> ";
			//envoie_trame_http("TYPvide");
		}
		if ($formEvt=="")
		{
			echo "le champ Evenement est vide <BR> ";
			//envoie_trame_http("EVTvide");
		}
		if ($formTel=="")
		{
			echo "le champ Telephone est vide <BR> ";
			//envoie_trame_http("TELvide");
		}
	}
}
else
{
	if($debug==1)
		echo "trame OK";
}

	
//Mise en forme du message au frontal*********************************************

/*Début de trame*/
$trame2frontal = chr(16)."_c810:001";
/*$trame2frontal .= "444:400,";
$trame2frontal .= "PR=IG,";
$trame2frontal .= "FA=ZZ,";
$trame2frontal .= "TRAME=";*/
/*****************/


	//Identificateur du transmetteur dans 't_q'*********************
	$trame2frontal .= ",UID=".$formId;
	//**************************************************************
				
	//Adresse IP  dans 'k_l'****************************************
	//sscanf($IP_client, "%u.%u.%u.%u",$IP_client_1, $IP_client_2, $IP_client_3, $IP_client_4);
	//$IP_client_1 = str_pad($IP_client_1,3,"0", STR_PAD_LEFT);
	//$IP_client_2 = str_pad($IP_client_2,3,"0", STR_PAD_LEFT);
	//$IP_client_3 = str_pad($IP_client_3,3,"0", STR_PAD_LEFT);
	//$IP_client_4 = str_pad($IP_client_4,3,"0", STR_PAD_LEFT);
	//$trame2frontal .= "k".$IP_client_1.".".$IP_client_2.".".$IP_client_3.".".$IP_client_4."l";
	$trame2frontal .= ",IP=".$IP_client;
	//**************************************************************

/*
for($nbEvt=1,$i=0;$i<strlen($formEvt);$i++)
{
	if($formEvt[$i]=='-')
		$nbEvt++;
}

for($i=0;$i<$nbEvt;$i++)
{
	//Type peripherique dans 'z_w'**********************************
	$trame2frontal .= "z".substr($formEvt,$i*13+$i+11,2)."w";
	//**************************************************************

	//State dans 'a_b'**********************************************
	$trame2frontal .= "a".substr($formEvt,$i*13+$i+8,3)."b";
	//**************************************************************


	
	//Date dans 'g_h'***********************************************
	$date_recue = mise_en_forme_date_recu(substr($formEvt,$i*13+$i+0,8));
	$trame2frontal .= "h".$date_recue."g";
	//**************************************************************
}	

*/


if($formTel[0]==' ')
  {
    $formTel2=array();
    $formTel2="0";
    $formTel2.=substr($formTel,3,strlen($formTel));
    //for($i=3;$formTel[$i];$i++)
    // $formTel2.=$formTel[$i];
    $trame2frontal .= ",TEL=".$formTel2;
   
  }
else
  $trame2frontal .= ",TEL=".$formTel;
	
$trame2frontal .= ",TRAME=".$formEvt;
	$trame2frontal .= ",PHONIE=".$formTrm;
	
	
	/*Fin de trame*/
	$trame2frontal .= "c_".chr(17).chr(18).chr(00);
	/**************/
	//Fin de mise en forme du message au frontal****************************************
			

	/*Affichage du message et de l'adresse à utiliser*/
	if($debug==1)
	{
		echo "$trame2frontal <BR>";
		echo "addresse ip client: $IP_client_1 $IP_client_2 $IP_client_3 $IP_client_4<BR>";
	}
	/*************************************************/
	

	//Envoie de la trame au Frontal ***************************************************
	/*Creation de la socket "socket_frontal" et demande de connexion*/
	//Mettre adresse du superviseur et le port de connexion
	$socket_frontal = connexion($addr_superviseur, $port);	
	/****************************************************************/

	if(!$socket_frontal)							//La connexion au frontal a échouée
	{
		if($debug==1)
			echo "Echec du protocole connexion<BR>";
	}
	else											//La connexion au frontal a réussie
	{
		if($debug==1)
			echo "Reussite du protocole connexion<BR>";

		/*Envoie de la trame au format t2i au frontal****************/
		if(!($ipResult=envoie_trame_socket($socket_frontal,$trame2frontal,"Frontal",$debug)))
		{	
			if($debug==1)
				echo "Echec du protocole envoie de trame au frontal<BR>";
		}
		else
		{
			if($debug==1)
				echo "Reussite du protocole envoie de trame au frontal<BR>";
			ferme_socket($socket_frontal);
			$protocole_frontal_OK = 1; 
		}
		/************************************************************/
	}
	//*******************************************************************************

	/*réponse au transmetteur*****************************************/
	if($protocole_frontal_OK == 1)
	{
		$resultat=mise_en_forme_date_envoi() .$ipResult;
		
		/*if($formTrm==1 && $modePhonie==2)
			$resultat .= ";Pho=Now,".$telPhonie;
		if($formTrm==1 && $modePhonie==1)
			$resultat .= ";Pho=3,".$telPhonie;	
		*/
		echo $resultat;
		
		//Envoyer l'ordre au frontal/spx de téléphoner au Transmetteur
		
	}
	/****************************************************************/

		
?>
